#-*- Makefile -*-

require DE_EPAGES::Core::API::Makefile;
__DATA__
#
#   makefile
#
#   Project : epages 6
#   Copyright   : ePages GmbH 2004
#   Version : Fri Dec 03 17:07:43 2010
#

!OS_SPECIFIC_DEFINES
DE_EPAGES   = .
COMPANY     = DE_EPAGES
STORE       = YourStore
SOURCEDOC   = $(MAKEDIR)\..\SourceDoc
SOURCEDOCDATE= Mon May 3 12:00:00 2012
EPAGES_VERSION_NUMBER= 6.17.40.1
EPAGES_VERSION= ePages $(EPAGES_VERSION_NUMBER)
EPAGES_TAG  = release_6_17_40_1
PATCH_TAG   = patch_6_17_40_1
#  ePagesJ release version:
#  - Use latest version available for MAIN. Should be the same as
#    $EPAGES_VERSION_NUMBER, but might be -1.
#  - Use equal version for pre-release branch.
EPAGESJ_VERSION= 6.17.40
EPAGES_NODEJS_VERSION= 6.17.40
SITE_NAME   = Site
STORE_TYPE  = Store
SITE_TYPE   = Site
!ifndef BASE_STORE_TYPE
BASE_STORE_TYPE = $(STORE_TYPE)
!endif
!ifndef BASE_SITE_TYPE
BASE_SITE_TYPE = $(SITE_TYPE)
!endif
BACKUP_NAME = Backup
PROVIDER_PATH = /Providers/Distributor
PROVIDER_USER = admin
PROVIDER_PASSWD = admin
DEMOSHOP_ALIAS = DemoShop
DEMOSHOP_SHOPTYPE = Demo
CARTRIDGE=ALL
# settings for multistore installations
MASTER_NAME  = Master
MASTER_TYPE  = Master
MULTISTORE_NAME  = MultiStore
MULTISTORE_TYPE  = MultiStore
MULTISTORESITE_TYPE  = MultiStoreSite
MASTER_PROVIDER_PATH = $(PROVIDER_PATH)
MULTISTORE_PROVIDER_PATH = $(PROVIDER_PATH)
MASTER_PROVIDER_USER = $(PROVIDER_USER)
MULTISTORE_PROVIDER_USER = $(PROVIDER_USER)
MASTER_PROVIDER_PASSWD = $(PROVIDER_PASSWD)
MULTISTORE_PROVIDER_PASSWD = $(PROVIDER_PASSWD)
MASTERSHOP_ALIAS = MasterShop
MASTERSHOP_SHOPTYPE = Demo
SUBSHOP_ALIAS_DROPSHIPPING = DropShipping
SUBSHOP_SHOPTYPE_DROPSHIPPING = DropShipping1000
SUBSHOP_ALIAS_ERETAIL = eRetail
SUBSHOP_SHOPTYPE_ERETAIL = ERetail1000
ORDER_INTEGRATION_DROPSHIPPING = BasketHandover
ORDER_INTEGRATION_ERETAIL = OrderSplitting

!ifeq ("$(BASE_STORE_TYPE)", "FlexStore")
IMPORT_STORE	=
!else
IMPORT_STORE	= import_store
!endif

!ifdef WINDOWS
NPM_EXE		= npm
IF_EXIST	= if exist
IF_NOT_EXIST	= if not exist
DO		=
!else
NPM_EXE		= $(EPAGES_PERL)/bin/npm.sh
!ifeq ("$(EPAGES_PROJECT)", "")
EPAGES_PROJECT	= epages6
!endif
SHELL		= /bin/bash
IF_EXIST	= [ ! -e
IF_NOT_EXIST	= [ -e
DO		= ] ||
EP_WEB_GROUP	= $(shell echo $${EPAGES_WEBGROUP:-ep_web} | sed 's/:.*//')
PKG		= $(shell test -f /etc/debian_version && echo deb || echo rpm)
!endif
MODULES_INI	= $(EPAGES_CARTRIDGES)\CPAN\EPAGES\PerlLib\$(OSNAME)\modules.ini

!ifndef EPAGES_REPO
EPAGES_REPO = ftp://ftp.epages.com/pub/epages/build/repo/$(EPAGES_VERSION_NUMBER)/latest
!endif
!ifndef PATCH_TGZ
PATCH_TGZ   = $(EPAGES_REPO)/patch/$(EPAGES_VERSION_NUMBER)/epages-$(EPAGES_VERSION_NUMBER)-patch.tar.gz
!endif
!ifndef PATCH_DIR
PATCH_DIR   = $(EPAGES_SHARED)\Patches\$(EPAGES_TAG)
!endif
DATA_DIR    = $(EPAGES_SHARED)\var-$(EPAGES_TAG)
BACKUP_DIR  = $(DATA_DIR)\backup\$(HOSTNAME)
LOG_DIR     = $(DATA_DIR)\logs\$(HOSTNAME)
TGT         = $(DATA_DIR)\tgt\$(HOSTNAME)

!ifneq ("$(STORE_PSWD)", "")
CREATEDB_PSWD=-dbpasswd "$(STORE_PSWD)"
STORECONF_PSWD=-storepasswd "$(STORE_PSWD)"
!endif
!ifneq ("$(STORE_KEY)", "")
STORECONF_KEY=-key "$(STORE_KEY)"
!endif

BUILD_STORETYPES =
INSTALLER_SCRIPTS = $(PERL) $(DE_EPAGES)/Installer/Scripts
ST_ARGS     = -storetype $(STORE_TYPE) -version $(EPAGES_VERSION_NUMBER)
DOWNLOAD_STORETYPES = $(INSTALLER_SCRIPTS)/downloadStoreTypes.pl -version $(EPAGES_VERSION_NUMBER)
INSTALL_STORETYPE_FROM_BASE = $(INSTALLER_SCRIPTS)/installStoreTypeFromBase.pl $(ST_ARGS)
INSTALL_STORETYPE  = $(INSTALLER_SCRIPTS)/installStoreType.pl $(ST_ARGS)

PRESENTATION_SCRIPTS = $(PERL) $(DE_EPAGES)/Presentation/Scripts
CTMPL_ARGS  = -storename $(STORE) -version $(EPAGES_VERSION_NUMBER)
DOWNLOAD_CTMPLS = $(PRESENTATION_SCRIPTS)/downloadCtmpls.pl $(CTMPL_ARGS)
INSTALL_CTMPLS_FROM_BASE = $(PRESENTATION_SCRIPTS)/installCtmplsFromBase.pl $(CTMPL_ARGS)

IMPORT      = $(PERL) $(DE_EPAGES)/Object/Scripts/import.pl -storename $(STORE)
DELETE      = $(PERL) $(DE_EPAGES)/Object/Scripts/delete.pl -storename $(STORE)
DBDUMPS     = $(PERL) $(DE_EPAGES)/Database/Scripts/DatabaseDumps.pl
PATCHFILES  = $(PERL) $(DE_EPAGES)/Core/Scripts/PatchFiles.pl
PATCHDB     = $(INSTALLER_SCRIPTS)/patchDatabase.pl
CREATEDB    = $(PERL) $(DE_EPAGES)/Database/Scripts/createDB.pl
DROPDB      = $(PERL) $(DE_EPAGES)/Database/Scripts/dropDB.pl
INSTALLDB   = $(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/installDatabase.pl
REGISTER    = $(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/registercartridges.pl
SYNC        = $(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/synccartridges.pl
STORECONF   = $(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/createStoreConf.pl
DROPTABLES  = $(PERL) $(DE_EPAGES)/Database/Scripts/dropAllTables.pl
STOREREDIRECT= $(PERL) $(DE_EPAGES)/Database/Scripts/redirectStoreConnections.pl
DEL_INI_SECTION= $(PERL) $(DE_EPAGES)/Core/Scripts/DelIniSection.pl
INSTALL_CPAN= $(INSTALLER_SCRIPTS)/installCPAN.pl
START_EPAGES= $(INSTALLER_SCRIPTS)/startService.pl appserver
STOP_EPAGES = $(INSTALLER_SCRIPTS)/stopService.pl appserver
START_CRON  = $(INSTALLER_SCRIPTS)/startService.pl cron
STOP_CRON   = $(INSTALLER_SCRIPTS)/stopService.pl cron
INSTALL_3RD_PARTY = $(INSTALLER_SCRIPTS)/install3rdParty.pl
UPDATE_EPAGESJ = $(INSTALLER_SCRIPTS)/update-epagesj.pl
UPDATE_NODEJS = $(INSTALLER_SCRIPTS)/update-nodejs.pl
EPNODE6     = $(PERL) $(EPAGES_PERL)/bin/epnode6.pl
PATCH_WEBINTERFACE = $(PERL) $(DE_EPAGES)/WebInterface/Scripts/patchWebInterface.pl
CONNECT_TO_JDB='use DE_EPAGES::Database::API::Connection qw(ConnectSite); { eval { ConnectSite("epagesj"); }; exit 1 if $$@; }'

makefile: Makefile.PL
	$(PERL) Makefile.PL
	@$(ECHONL) "Please restart '$(MAKE)' again, makefile was updated." && $(PERL) -e "exit 1;"

test_store: makefile
	$(PERL) -e "exit ('$(STORE)' eq 'YourStore' ? 1 : 0);"

stop: makefile
	$(STOP_EPAGES)

start: makefile
!ifdef WINDOWS
	$(START_EPAGES)
!else
	IGNORE_INI=1 $(START_EPAGES)
!endif

stop_cron: makefile
	$(STOP_CRON)

start_cron: makefile
	$(START_CRON)

doc: makefile
	$(PERL) $(DE_EPAGES)/SourceDoc/Scripts/DocDir.pl -source $(EPAGES_CARTRIDGES) -target $(SOURCEDOC) -title "$(EPAGES_VERSION)" -ext pm -date "$(SOURCEDOCDATE)" $(EPAGES_CARTRIDGES)\DE_EPAGES

restart: makefile stop start

purge_configuration:
	$(DEL) $(EPAGES_CONFIG)\*.ept
	$(DEL) $(EPAGES_CONFIG)\*\*.ept
	$(DEL) $(EPAGES_CONFIG)\*.initial
	$(DEL) $(EPAGES_CONFIG)\*\*.initial
	$(DEL) $(EPAGES_CONFIG)\*~
	$(DEL) $(EPAGES_CONFIG)\*\*~

clean: makefile
!ifdef WINDOWS
	del /Q /S .*#* *.pdb
	dir /S /B /A:D | grep "Generated$$" | xargs "$(RMDIR)"
	dir /S /B /A:-D | grep "makefile$$" | xargs "$(DEL)"
!endif

test: makefile test_store
	$(INSTALLER_SCRIPTS)/runTests.pl -storename $(STORE)

delete_tables: test_store
	$(DROPTABLES) -storename $(STORE)

cleanfiles_global: makefile
	$(EMPTY_DIR) $(EPAGES_WEBROOT)\_MONITOR_
	$(EMPTY_DIR) $(EPAGES_STORES)\_MONITOR_
	$(EMPTY_DIR) $(EPAGES_SHARED)\Static
	$(DEL) $(EPAGES_LOG)\*

install_storetype:
!ifndef EPAGES_IGNORE_STORETYPE
!ifeq ("$(CARTRIDGE)$(BUILD_STORETYPES)", "ALL")
	{ $(DOWNLOAD_STORETYPES) && $(INSTALL_STORETYPE_FROM_BASE); } || $(MAKE) build_storetype
!else
	$(MAKE) build_storetype
!endif
!endif

build_storetype:
	$(INSTALL_STORETYPE) $(CARTRIDGE)
	$(PERL) $(DE_EPAGES)/JQuery/Scripts/DictionaryConverter.pl -cartridge $(CARTRIDGE) $(ST_ARGS)
!ifneq ("$(DOJOBUILD)", "0")
	$(MAKE) build_dojo STORE_TYPE=$(STORE_TYPE)
!endif
!ifneq ("$(UIBUILD)", "0")
	$(MAKE) build_ui STORE_TYPE=$(STORE_TYPE)
!endif

cleanfiles_storetype:
!ifndef EPAGES_IGNORE_STORETYPE
	$(DEL) $(EPAGES_CONFIG)\StoreTypes.d\$(EPAGES_VERSION_NUMBER)\$(STORE_TYPE).conf
	$(RMDIR) $(EPAGES_WEBROOT)\StoreTypes\$(EPAGES_VERSION_NUMBER)\$(STORE_TYPE)
!endif

reinstall_storetype: makefile cleanfiles_storetype install_storetype

cleanfilesdb: makefile test_store
	$(RMDIR) $(EPAGES_WEBROOT)\$(STORE)
	$(RMDIR) $(EPAGES_STORES)\$(STORE)
	$(DEL) $(EPAGES_CONFIG)\Cartridges.d\$(STORE).conf

cleandb: makefile test_store
	$(PERL) $(DE_EPAGES)/WebInterfacePoolDB/Scripts/deleteStore.pl -storename $(STORE)
	$(MAKE) delete_tables STORE=$(STORE)

import_store: test_store
	@$(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/store.pl -sitename $(SITE_NAME) -action insert -storename $(STORE)

import_distributor:
	$(IMPORT) $(DE_EPAGES)/ShopConfiguration/Database/XML/Distributor.xml
!ifneq ("$(BASE_SITE_TYPE)", "FlexSite")
	$(IMPORT) $(DE_EPAGES)/ShopConfiguration/Database/XML/DistributorStore.xml
!endif

import_shoptypes: makefile test_store
	$(IMPORT) -path $(PROVIDER_PATH) $(DE_EPAGES)/ShopConfiguration/Database/XML/DistributorShopTypes.xml

install_demoshop: makefile
	$(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/createShop.pl \
		-wsuser $(PROVIDER_PATH)/Users/$(PROVIDER_USER) -passwd $(PROVIDER_PASSWD) \
		-shoptype $(DEMOSHOP_SHOPTYPE) -storename $(STORE) \
		-alias $(DEMOSHOP_ALIAS) -scriptname $(DEMOSHOP_ALIAS)
	$(PERL) $(DE_EPAGES)/RemoteSearch/Scripts/manageIndex.pl -storename $(STORE) -shop $(DEMOSHOP_ALIAS) -update
	$(MAKE) permissions PERM_ARGS=-u SECTION=webroot

demoshop_shopwizard:
	$(PERL) $(DE_EPAGES)/ShopWizard/Scripts/runWizard.pl -storename $(STORE) -shop $(DEMOSHOP_ALIAS) -config $(EPAGES_CONFIG)/ShopWizard.conf -nooutput

uninstall_demoshop: makefile
	$(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/deleteShop.pl -wsuser $(PROVIDER_PATH)/Users/$(PROVIDER_USER) -passwd $(PROVIDER_PASSWD) -alias $(DEMOSHOP_ALIAS)

install_diagnostics: makefile test_store
	cd $(DE_EPAGES)\Diagnostics && $(PERL) Makefile.PL
	cd $(DE_EPAGES)\Diagnostics && $(MAKE) install STORE=$(STORE) EPAGES_VERSION=$(EPAGES_VERSION_NUMBER)

install_store: makefile test_store
	$(INSTALLDB) -storename $(STORE) -sitename $(SITE_NAME)
!ifdef DROP_CTMPLS
	$(MAKE) cleanfiles_ctmpls
!else
	$(DOWNLOAD_CTMPLS) ; $(INSTALL_CTMPLS_FROM_BASE)
!endif
	$(MAKE) synchronize STORE=$(STORE)
!ifneq ("$(STORE)", "Site")
	-$(PERL) $(DE_EPAGES)/RemoteSearch/Scripts/remoteSearch.pl -storename $(STORE) -state on
!endif
	$(MAKE) permissions PERM_ARGS=-u SECTION=webroot
	$(MAKE) permissions PERM_ARGS=-u SECTION=stores

synchronize: makefile test_store
!ifndef EPAGES_IGNORE_SITE
	$(SYNC) -storename $(STORE) -sitename $(SITE_NAME)
!endif

create_store_conf:
	$(STORECONF) -storename $(STORE) -storetype $(STORE_TYPE) $(STORECONF_PSWD) $(STORECONF_KEY)

new_store:
	$(MAKE) create_store_conf create_db $(IMPORT_STORE) install_store STORE=$(STORE) STORE_TYPE=$(STORE_TYPE) BACKUP_NAME=$(BACKUP_NAME)

install_jdb:
	$(MAKE) has_jdb 2>/dev/null || $(MAKE) create_jdb

uninstall_jdb:
	-$(IF_EXIST) /etc/init.d/epagesj $(DO) service epagesj stop
	$(MAKE) drop_db cleanfilesdb STORE=epagesj

create_jdb:
	$(STORECONF) -storename epagesj -storedbname epagesj
	$(MAKE) create_db STORE=epagesj BACKUP_NAME=$(BACKUP_NAME)
	$(MAKE) restart_jdb SKIP_MONGO_ENABLE_AUTH=1
restart_jdb:
!ifdef RESTART_J
	$(MAKE) has_jdb_connection >/dev/null 2>&1\
 && SKIP_MONGO_ENABLE_AUTH=$(SKIP_MONGO_ENABLE_AUTH) /etc/init.d/epagesj restart || true
!ifndef SKIP_UPDATE_OS
	$(MAKE) check_epagesj
!endif
!endif
has_jdb:
	$(PERL) -e $(CONNECT_TO_JDB) >/dev/null 2>&1
has_jdb_connection:
# if service does not exist -> do not restart it
	$(IF_NOT_EXIST) /etc/init.d/epagesj $(DO) exit 1
# if we cant find out the connection status -> restart it
	$(IF_NOT_EXIST) /var/epages/CheckMySQLConnection.sh $(DO) exit 0
# if connection exists -> restart it
	/var/epages/CheckMySQLConnection.sh epagesj

install_pooldb:
	$(MAKE) create_store_conf create_db STORE=ASPoolDB STORE_TYPE=ASPoolDB
	$(INSTALLDB) -storename ASPoolDB

uninstall_pooldb:
	$(MAKE) drop_db cleanfilesdb STORE=ASPoolDB
	$(DEL) $(EPAGES_CONFIG)\Cartridges.d\ASPoolDB.conf

reinstall_pooldb:
	$(MAKE) stop
	$(MAKE) uninstall_pooldb
	$(MAKE) install_pooldb
	$(MAKE) start

install_systemdb:
	$(MAKE) create_store_conf create_db STORE=System STORE_TYPE=System
	$(INSTALLDB) -storename System

uninstall_systemdb:
	$(MAKE) drop_db cleanfilesdb STORE=System
	$(DEL) $(EPAGES_CONFIG)\Database.d\System.conf

install_cpan: makefile
	$(IF_EXIST) $(MODULES_INI) $(DO) $(MAKE) install_cpan_epages

install_cpan_epages:
	$(INSTALL_CPAN) CPAN::EPAGES
	$(MAKE) permissions PERM_ARGS=-u

preinstall:
	$(IF_EXIST) $(MODULES_INI) $(DO) $(MAKE) stop install_cpan start
	$(MAKE) update_os
!ifndef SKIP_ALIVE_CHECK
	$(PERL) $(DE_EPAGES)/WebInterface/Scripts/checkWI.pl -all
!endif
	$(MAKE) install_pooldb
!ifneq ("$(EPAGES_BUSINESS_UNITS)", "FlexSite")
	$(MAKE) install_systemdb
!endif
	$(STORECONF) -storename PatchSystemInfoDB -storelogin usr_patch -backuphost none

install: makefile
	$(MAKE) preinstall
!ifndef EPAGES_IGNORE_SITE
	$(MAKE) create_store_conf install_storetype STORE=Site STORE_TYPE=$(BASE_SITE_TYPE)
	$(MAKE) create_db install_store STORE=Site STORE_TYPE=$(BASE_SITE_TYPE)
!endif
!ifndef EPAGES_IGNORE_STORE
	$(MAKE) create_store_conf install_storetype STORE=Store STORE_TYPE=$(BASE_STORE_TYPE)
	$(MAKE) create_db $(IMPORT_STORE) install_store STORE=Store
!endif
!ifndef EPAGES_IGNORE_SITE
	$(MAKE) import_distributor STORE=Site
	$(MAKE) import_shoptypes STORE=Site
!endif
	$(MAKE) restart_jdb RESTART_J=1
!ifndef EPAGES_IGNORE_STORE
!ifndef EPAGES_IGNORE_DEMOSHOP
	$(MAKE) install_demoshop STORE=Store DEMOSHOP_SHOPTYPE=$(DEMOSHOP_SHOPTYPE)
!endif
!endif
!ifdef EPAGES_BUSINESS_UNITS
	$(MAKE) $(EPAGES_BUSINESS_UNITS)
!endif
	$(MAKE) start_cron

reinstall: makefile uninstall
	$(DEL) $(EPAGES_CONFIG)/Database.d/Store.conf
	$(MAKE) create_store_conf STORE=Store STORE_TYPE=$(STORE_TYPE)
	$(MAKE) install UPDATE_OS=reinstall STORE_TYPE=$(STORE_TYPE) DEMOSHOP_SHOPTYPE=$(DEMOSHOP_SHOPTYPE) BUILD_STORETYPES=1 DROP_CTMPLS=1
!ifndef EPAGES_IGNORE_SITE
	$(MAKE) install_diagnostics STORE=Site EPAGES_VERSION_NUMBER=$(EPAGES_VERSION_NUMBER)
!endif
!ifndef EPAGES_IGNORE_STORE
	$(MAKE) install_diagnostics STORE=Store EPAGES_VERSION_NUMBER=$(EPAGES_VERSION_NUMBER)
!endif

reinstall_fast:
	$(MAKE) reinstall DEMOSHOP_SHOPTYPE=MinDemo STORE_TYPE=MinStore EPAGES_IGNORE_STORETYPE=1 SKIP_UPDATE_OS=1
	$(MAKE) demoshop_shopwizard STORE=Store

uninstall_common: makefile cleanfiles_global
	$(MAKE) uninstall_pooldb
!ifneq ("$(EPAGES_BUSINESS_UNITS)", "FlexSite")
	$(MAKE) uninstall_systemdb
!endif
	$(DEL) $(EPAGES_CONFIG)\EbayCategories.db

uninstall: uninstall_common
!ifdef EPAGES_BUSINESS_UNITS
	$(MAKE) $(EPAGES_BUSINESS_UNITS) UNINSTALL_BU=1
!endif
!ifndef EPAGES_IGNORE_SITE
	$(MAKE) drop_db cleanfilesdb cleanfiles_storetype STORE=Site STORE_TYPE=$(BASE_SITE_TYPE) EPAGES_VERSION_NUMBER=$(EPAGES_VERSION_NUMBER)
!endif
!ifndef EPAGES_IGNORE_STORE
	$(MAKE) drop_db cleanfilesdb cleanfiles_storetype STORE=Store STORE_TYPE=$(BASE_STORE_TYPE) EPAGES_VERSION_NUMBER=$(EPAGES_VERSION_NUMBER)
!endif

build_dojo:
!ifneq ("$(DOJOBUILD)", "0")
	$(PERL) $(EPAGES_CARTRIDGES)/DE_EPAGES/Dojo/Scripts/build.pl $(ST_ARGS) -config Dojo/Scripts/build2.conf
	$(PERL) $(EPAGES_CARTRIDGES)/DE_EPAGES/Dojo/Scripts/build.pl $(ST_ARGS)
!endif

build_ui:
!ifneq ("$(UIBUILD)", "0")
	$(PRESENTATION_SCRIPTS)/buildUi.pl $(ST_ARGS)
!endif

reinstall_store: makefile test_store cleandb cleanfilesdb install_store

# create databases

create_db: makefile
	$(CREATEDB) -storename $(STORE) -connection $(BACKUP_NAME) $(CREATEDB_PSWD)

drop_db: makefile
	$(DROPDB) -storename $(STORE)

# patch

close_store:
	$(STOREREDIRECT) -storename $(STORE) -redirect StoreClosed.html

open_store:
	$(STOREREDIRECT) -storename $(STORE) -remove

patch_store: makefile test_store
	$(PATCHDB)   -nosync -storename $(STORE)
	$(INSTALLDB) -nosync -storename $(STORE)

update_latest: makefile
	cvs -q update -A -d -P
	$(MAKE) permissions SECTION=cartridges
	$(MAKE) restart

latest: makefile update_latest reinstall
renew: latest

update_stable: makefile
	cvs -q update -d -P -r stable
	$(MAKE) permissions SECTION=cartridges
	$(MAKE) restart

stable: makefile update_stable reinstall

update_os:
!ifndef SKIP_UPDATE_OS
!ifdef WINDOWS
	echo. & set EPAGES_REPO=$(EPAGES_REPO) & $(INSTALL_3RD_PARTY) graphviz jdk mongodb mp3splt nodejs
	echo. & set EPAGES_REPO=$(EPAGES_REPO) & $(UPDATE_NODEJS) -version $(EPAGES_NODEJS_VERSION)
	echo. & set EPAGES_REPO=$(EPAGES_REPO) & $(UPDATE_EPAGESJ) -version $(EPAGESJ_VERSION)
!else
!ifeq ("$(UPDATE_OS)", "reinstall")
	/var/epages/SetRepository.sh -r $(EPAGES_REPO) -b $(EPAGES_VERSION_NUMBER)
!endif
	ENABLE_REPO=epages-base /var/epages/install-RPM.sh --update epages-requires
	ENABLE_REPO=epages-base /var/epages/install-RPM.sh --update-only epages-webconf
	ENABLE_REPO=epages-update /var/epages/install-RPM.sh --update graphviz mp3splt
	ENABLE_REPO=epages-update /var/epages/install-RPM.sh --update epages-nodejs
	ENABLE_REPO=epages-update /var/epages/install-RPM.sh --update epages-j
!endif
!endif
	$(MAKE) install_jdb RESTART_J=1
!ifeq ("$(UPDATE_OS)", "reinstall")
	$(PATCH_WEBINTERFACE) --$(UPDATE_OS)
!endif

build_patch_sh:
!ifndef WINDOWS
	if type -p build-patch-sh.sh ; then rm -rf "$(PATCH_DIR)"/sh ;\
 build-patch-sh.sh -r "$(EPAGES_TAG)" -P "$(PATCH_TAG)" -t "$(PATCH_DIR)"/sh ; fi
!endif

permissions:
!ifndef WINDOWS
	$(ETC_INITD) perm admin $(PERM_ARGS)
!ifdef SECTION
	$(ETC_INITD) perm $(SECTION) $(PERM_ARGS)
!endif
!endif

# epages business units

Site:
Store:

MultiStore Master:
!ifdef UNINSTALL_BU
	$(MAKE) uninstall_multistore
!else
	$(MAKE) install_multistore
!ifndef EPAGES_IGNORE_DEMOSHOP
	$(MAKE) install_multistore_demo
!endif
!endif

FlexStore:
!ifdef UNINSTALL_BU
	$(MAKE) uninstall_flexstore
!else
	$(MAKE) install_flexstore
!endif

FlexSite:
!ifdef UNINSTALL_BU
	$(MAKE) uninstall_flexsite
!else
	$(MAKE) install_flexsite
!ifndef WINDOWS
	/var/epages/ini-config.sh -i -f $(EPAGES_CONFIG)/Scheduler.conf -s LOOPS -k Store -v "-storename Site"
!endif
!endif

install_multistore: makefile
!ifneq ("$(MASTER_NAME)", "$(MULTISTORE_NAME)")
	$(MAKE) preinstall
	$(MAKE) create_store_conf install_storetype STORE=$(SITE_NAME) STORE_TYPE=$(MULTISTORESITE_TYPE)
	$(MAKE) create_db install_store STORE=$(SITE_NAME) STORE_TYPE=$(MULTISTORESITE_TYPE)
	$(MAKE) new_store STORE=$(SITE_NAME) STORE_TYPE=$(MULTISTORESITE_TYPE)
	$(MAKE) import_multistoresite_distributor STORE=$(SITE_NAME)
	$(MAKE) import_multistoresite_shoptypes STORE=$(SITE_NAME)
	$(MAKE) synchronize STORE=$(SITE_NAME)
	$(MAKE) create_store_conf install_storetype STORE=$(MASTER_NAME) STORE_TYPE=$(MASTER_TYPE)
	$(MAKE) create_store_conf install_storetype STORE=$(MULTISTORE_NAME) STORE_TYPE=$(MULTISTORE_TYPE)
	$(MAKE) new_store STORE=$(MASTER_NAME) STORE_TYPE=$(MASTER_TYPE)
	$(MAKE) new_store STORE=$(MULTISTORE_NAME) STORE_TYPE=$(MULTISTORE_TYPE)
	$(MAKE) import_multistore_distributor
	$(MAKE) import_multistore_shoptypes
!else
	@echo  Master and MultiStore have to be installed at different databases.
!endif

import_multistoresite_distributor:
	$(IMPORT) $(DE_EPAGES)/ShopConfiguration/Database/XML/Distributor.xml

import_multistoresite_shoptypes:
	$(IMPORT) -path $(PROVIDER_PATH) $(DE_EPAGES)/ShopConfiguration/Database/XML/DistributorShopTypes.xml

uninstall_multistore: uninstall_common
	$(MAKE) cleanfiles_storetype STORE_TYPE=$(MASTER_TYPE)
	$(MAKE) cleanfiles_storetype STORE_TYPE=$(MULTISTORE_TYPE)
	$(MAKE) cleanfiles_storetype STORE_TYPE=$(MULTISTORESITE_TYPE)
	$(MAKE) drop_db cleanfilesdb STORE=$(MASTER_NAME)
	$(MAKE) drop_db cleanfilesdb STORE=$(MULTISTORE_NAME)
	$(MAKE) drop_db cleanfilesdb STORE=$(SITE_NAME)
	$(DEL) $(EPAGES_CONFIG)/Database.d/$(SITE_NAME).conf
	$(DEL) $(EPAGES_CONFIG)/Database.d/$(MULTISTORE_NAME).conf
	$(DEL) $(EPAGES_CONFIG)/Database.d/$(MASTER_NAME).conf

reinstall_multistore: makefile
	$(MAKE) uninstall_multistore
	$(MAKE) install_multistore UPDATE_OS=reinstall BUILD_STORETYPES=1 DROP_CTMPLS=1

reinstall_multistore_complete: makefile
	$(MAKE) uninstall_multistore
	$(MAKE) install_multistore_complete UPDATE_OS=reinstall BUILD_STORETYPES=1 DROP_CTMPLS=1

cleanfiles_ctmpls:
!ifndef WINDOWS
	rm -rf  $(EPAGES_SHARED)/Static/$(STORE)/Templates
	rm -rf  $(EPAGES_SHARED)/Static/Templates.d/$(EPAGES_VERSION_NUMBER)/$(STORE_TYPE)
!endif

install_multistore_complete: makefile
	$(DEL) $(EPAGES_CONFIG)/Database.d/Site.conf
	$(MAKE) cleanfiles_ctmpls STORE_TYPE=Site STORE=Site
	$(MAKE) install_multistore MULTISTORESITE_TYPE=$(MULTISTORESITE_TYPE)
	$(MAKE) install_multistore_demo
	$(MAKE) install_diagnostics STORE=$(MASTER_NAME)
	$(MAKE) install_diagnostics STORE=$(MULTISTORE_NAME)
	$(MAKE) install_diagnostics STORE=$(SITE_NAME)

install_multistore_demo: makefile
	$(MAKE) install_mastershop
	$(MAKE) install_subshop SUBSHOP_ALIAS=$(SUBSHOP_ALIAS_DROPSHIPPING) SUBSHOP_SHOPTYPE=$(SUBSHOP_SHOPTYPE_DROPSHIPPING)
	$(MAKE) install_subshop SUBSHOP_ALIAS=$(SUBSHOP_ALIAS_ERETAIL) SUBSHOP_SHOPTYPE=$(SUBSHOP_SHOPTYPE_ERETAIL)
	$(MAKE) assign_subshop_to_mastershop SUBSHOP_ALIAS=$(SUBSHOP_ALIAS_DROPSHIPPING) ORDER_INTEGRATION=$(ORDER_INTEGRATION_DROPSHIPPING)
	$(MAKE) assign_subshop_to_mastershop SUBSHOP_ALIAS=$(SUBSHOP_ALIAS_ERETAIL) ORDER_INTEGRATION=$(ORDER_INTEGRATION_ERETAIL)

install_mastershop: makefile
	$(MAKE) install_demoshop STORE=$(MASTER_NAME) DEMOSHOP_ALIAS=$(MASTERSHOP_ALIAS) PROVIDER_PATH=$(MASTER_PROVIDER_PATH) PROVIDER_USER=$(MASTER_PROVIDER_USER) DEMOSHOP_SHOPTYPE=$(MASTERSHOP_SHOPTYPE)
	$(PERL) $(DE_EPAGES)/Shop/Scripts/setMaxFeature.pl -storename $(MASTER_NAME) -shopname $(MASTERSHOP_ALIAS) -featurename MultiStoreMaster -featurevalue 1

install_subshop: makefile
	$(MAKE) install_demoshop STORE=$(MULTISTORE_NAME) DEMOSHOP_ALIAS=$(SUBSHOP_ALIAS) PROVIDER_PATH=$(MULTISTORE_PROVIDER_PATH) PROVIDER_USER=$(MULTISTORE_PROVIDER_USER) DEMOSHOP_SHOPTYPE=$(SUBSHOP_SHOPTYPE)

import_multistore_shoptypes: makefile
	$(PERL) $(DE_EPAGES)/Object/Scripts/import.pl -storename $(SITE_NAME) -path $(MASTER_PROVIDER_PATH) $(DE_EPAGES)/MultiStoreProvider/Database/XML/DistributorShopTypesDropShipping.xml
	$(PERL) $(DE_EPAGES)/Object/Scripts/import.pl -storename $(SITE_NAME) -path $(MASTER_PROVIDER_PATH) $(DE_EPAGES)/MultiStoreProvider/Database/XML/DistributorShopTypesERetail.xml

import_multistore_distributor: makefile
	$(PERL) $(DE_EPAGES)/Object/Scripts/import.pl -storename $(SITE_NAME) $(DE_EPAGES)/MultiStoreProvider/Database/XML/DistributorMultiStore.xml

assign_subshop_to_mastershop: makefile
	$(PERL) $(DE_EPAGES)/MultiStoreProvider/Scripts/assignSubShopToMasterShop.pl -mastershop $(MASTERSHOP_ALIAS) -subshop $(SUBSHOP_ALIAS) -affiliateshopid $(SUBSHOP_ALIAS) -orderintegration $(ORDER_INTEGRATION)

install_flexstore:
	cd $(DE_EPAGES)\Flex && $(PERL) Makefile.PL
	cd $(DE_EPAGES)\Flex && $(MAKE) install_service update_scheduler

uninstall_flexstore:
	cd $(DE_EPAGES)\Flex && $(PERL) Makefile.PL
	cd $(DE_EPAGES)\Flex && $(MAKE) uninstall_service

install_flexsite:
uninstall_flexsite:

# epages java
check_epagesj: makefile
	$(PERL) $(DE_EPAGES)/EPagesJ/Scripts/checkEPagesJ.pl -tries 10 -version $(EPAGESJ_VERSION)

activate_java_search:
	-$(PERL) $(DE_EPAGES)/RemoteSearch/Scripts/remoteSearch.pl -storename $(STORE) -state on
	$(PERL) $(DE_EPAGES)/RemoteSearch/Scripts/manageIndex.pl -storename $(STORE) -all -update

add_mongo_service:
	$(INSTALLER_SCRIPTS)/addMongoService.pl

add_epagesj_services:
	$(INSTALLER_SCRIPTS)/addJavaServices.pl
#
# END
#
